#!/usr/bin/perl
# NOTE: The general mentality for this whole script is the following -- the
# only thing that's safe to pass around is the user, and the reason for that is
# because the 'checks and balances' guarantees that the user will be included
# in the email sent out -- so if someone decides to fill out a status report on
# your behalf, at least you can dispute it since you will know about it. That
# said, everything gets looked up from the DB at each stage that it's needed.
# Ex: if you need to figure out an email, don't pass it around -- look it up.

# NOTE2: There is an 'username' and an 'email' field, and currently, they are
# both 'fas user IDs', but the email field has the @fas.harvard.edu. The reason
# for this is to give us some expansion room in the future and to allow people
# to use their @harvard.edu addresses uopon request. It's really just for
# flexiblity. For this reason, look up both values.


use CGI;
use DBI;
use MIME::Lite;

my $cgi = new CGI;


# IF THE FORM HAS BEEN SUBMITED..."fire the missles" (www.youtube.com/watch?v=nZMwKPmsbWE) 
if(defined($cgi->param("form"))) {


	# Start Error Detection
	if(($cgi->param("username") eq '')) {
		$msg = "Please fill in the '<font color='red'>Status Report for:</font>' field!";
		&error($msg);
	}
	elsif(($cgi->param("one_1") eq '')) {
		$msg = "Please fill in at least one line from the '<font color='red'>Project-Related Work for the week</font>' section!";
		&error($msg);
	}
	elsif(($cgi->param("two_1") eq '')) {
		$msg = "Ok...Seriously? Stop hitting enter!<br> Maybe you don't deserve this fancy error checking! <br><br>Next time, this is what's going to be submited as your accomplishment:<br> <img src='http://www.people.fas.harvard.edu/~ventz/images/monkey_news.jpg'><br><br>Please fill in at least one line from the '<font color='red'>Ops-Related Work for the week</font>' section!";
		&error($msg);
	}
	# End Error Detection
	


	# FORM SUBMITED ALREADY - ACTUAL EMAIL CREATION
	my $user=$cgi->param("username");

	# Given the username, pull:
	# 1.) email and team for user
	# 2.) based on team, pull info for teamlead
	# 3.) pull info for supervisor


	# START DB section
	my $dbh = DBI->connect("dbi:SQLite:dbname=/etc/apache2/DB/status.db","","");
	my $fst_user = $dbh->selectall_arrayref("SELECT username,first_name,last_name,email,team FROM staff WHERE username='$user'");
	@user_array = @{$fst_user};
	my $username = $user_array[0][0]; 
	my $first_name = $user_array[0][1]; 
	my $last_name = $user_array[0][2]; 
	my $email = $user_array[0][3]; 
	my $team = $user_array[0][4]; 
	my $name = "$first_name $last_name";

	my $fst_teamlead = $dbh->selectall_arrayref("SELECT username,first_name,last_name,email FROM teamleads WHERE team='$team'");
	@teamlead_array = @{$fst_teamlead};
	my $tl_username = $teamlead_array[0][0]; 
	my $tl_first_name = $teamlead_array[0][1]; 
	my $tl_last_name = $teamlead_array[0][2]; 
	my $tl_email = $teamlead_array[0][3]; 

	my $fst_supervisor = $dbh->selectall_arrayref("SELECT username,first_name,last_name,email FROM supervisors ORDER BY first_name ASC");
	@supervisor_array = @{$fst_supervisor};
	my $sv_username = $supervisor_array[0][0]; 
	my $sv_first_name = $supervisor_array[0][1]; 
	my $sv_last_name = $supervisor_array[0][2]; 
	my $sv_email = $supervisor_array[0][3]; 

	$dbh->disconnect;
	# END DB section

	# Note - array of arrays is returned
	my $one_1=$cgi->param("one_1"); my $one_2=$cgi->param("one_2");my $one_3 = $cgi->param("one_3");
	my $one_4=$cgi->param("one_4"); my $one_5=$cgi->param("one_5");
	my $two_1=$cgi->param("two_1"); my $two_2=$cgi->param("two_2");my $two_3 = $cgi->param("two_3");
	my $two_4=$cgi->param("two_4"); my $two_5=$cgi->param("two_5");
	my $three_1=$cgi->param("three_1");my $three_2=$cgi->param("three_2");my$three_3=$cgi->param("three_3");
	my $three_4=$cgi->param("three_4"); my $three_5=$cgi->param("three_5");

	my $summary = "PROJECT-RELATED WORK FOR THE WEEK (Mon-Fri)";
	$summary = $summary . "\n1.) $one_1" if ($one_1 ne '');
	$summary = $summary . "\n2.) $one_2" if ($one_2 ne '');
	$summary = $summary . "\n3.) $one_3" if ($one_3 ne '');
	$summary = $summary . "\n4.) $one_4" if ($one_4 ne '');
	$summary = $summary . "\n5.) $one_5" if ($one_5 ne '');
	$summary = $summary . "\n\nOPS-RELATED WORK FOR THE WEEK (Mon-Fri)";
	$summary = $summary . "\n1.) $two_1" if ($two_1 ne '');
	$summary = $summary . "\n2.) $two_2" if ($two_2 ne '');
	$summary = $summary . "\n3.) $two_3" if ($two_3 ne '');
	$summary = $summary . "\n4.) $two_4" if ($two_4 ne '');
	$summary = $summary . "\n5.) $two_5" if ($two_5 ne '');
	$summary = $summary . "\n\nNOTABLES";
	$summary = $summary . "\n1.) $three_1" if ($three_1 ne '');
	$summary = $summary . "\n2.) $three_2" if ($three_2 ne '');
	$summary = $summary . "\n3.) $three_3" if ($three_3 ne '');
	$summary = $summary . "\n4.) $three_4" if ($three_4 ne '');
	$summary = $summary . "\n5.) $three_5" if ($three_5 ne '');
	

	my $ip = 'n/a'; $ip = $cgi->remote_host();

	# LOG INFO TO TABLE -- NOTE: WE WILL NEVER!! (REPEAT: NEVER) LOG STATUS REPORTS!
	my $dbh = DBI->connect("dbi:SQLite:dbname=/etc/apache2/DB/status.db","","");
	$dbh->do("
                insert into submit
                (username, first_name, last_name, email, team, ip)
                values
                (\"$username\",\"$first_name\", \"$last_name\",\"$email\", \"$team\", \"$ip\")
        ");
	$dbh->disconnect;

	# SEND ACTUAL EMAIL
	my $to = "$sv_email, $tl_email"; my $cc = "$email";
	&sendemail($to, $cc, "Status Report for: $name", $summary);

	# WAVE OFF THE PERSON!
	print $cgi->header;
	print $cgi->start_html(-title=>"Thank You $name!");
	print $cgi->h3("Thank you $name!");
	print $cgi->p("Your report has been submited to <font color='red'>$sv_first_name $sv_last_name</font> and <font color='red'>$tl_first_name $tl_last_name</font>! Check your inbox (<font color='red'>$email</font>) for a copy.");
	print $cgi->end_html;
}



else {
	# This is if you have this pre-defined in the URL -- aka, if you came from the cron link
	my $user = '';
	if($cgi->param("username")) { $user = $cgi->param("username"); }

	# START DB section
	my $dbh = DBI->connect("dbi:SQLite:dbname=/etc/apache2/DB/status.db","","");
	my $fst = $dbh->selectall_arrayref("SELECT * FROM staff ORDER BY first_name ASC");
	$dbh->disconnect;
	# END DB section


	print "Content-type:text/html\r\n\r\n";
	print "<html><head><title>Status Review</title></head>";
	print "<body>
	<!--ACTUAL WEB STUFF-->
	<center>
	<form action='/cgi-bin/status.cgi' method='post'>
	<h1>Status Review</h1>";

	if($user eq '') {
		print "
		<table border='1' bordercolor='red' cellpadding='10' cellspacing='0'>
		<tr><td>";
	}

	print "Status Report for: <select name='username'><option value=\"\"></option>";

	# START DYNAMIC section
	foreach my $row (@$fst) {
		my ($username,$first_name, $last_name, $email, $team, $date) = @$row;
		if($username eq $user) {
			print "<option value=\"$username\" selected>$first_name $last_name - $username</option>";
		}
		else {
			print "<option value=\"$username\">$first_name $last_name - $username</option>";
		}
	}
	# END DYNAMIC section

	print "</select>";
	if($user eq '') {
		print "</table>";
	}

	print "
	<hr size='6' noshade style='width:600px'>
	<h2>Project-Related Work for the week</h2>
	(Enter up to 5 points - focus on impact, highlight specific projects)<br>
	1.) <input type='text' name='one_1' size='72' maxlength='80'/><br>
	2.) <input type='text' name='one_2' size='72' maxlength='80'/><br>
	3.) <input type='text' name='one_3' size='72' maxlength='80'/><br>
	4.) <input type='text' name='one_4' size='72' maxlength='80'/><br>
	5.) <input type='text' name='one_5' size='72' maxlength='80'/><br><br>
	<hr size='6' noshade style='width:600px'>

	<h2>Ops-Related Work for the week</h2>
	(Enter up to 5 points - focus on impact, highlight specific ops/tasks)<br>
	1.) <input type='text' name='two_1' size='72' maxlength='80'/><br>
	2.) <input type='text' name='two_2' size='72' maxlength='80'/><br>
	3.) <input type='text' name='two_3' size='72' maxlength='80'/><br>
	4.) <input type='text' name='two_4' size='72' maxlength='80'/><br>
	5.) <input type='text' name='two_5' size='72' maxlength='80'/><br><br>
	<hr size='6' noshade style='width:600px'>

	<h2>Notables </h2>
	(Enter up to 5 points - Risks/Obstacles/Issues/Heads-up/ETC)<br>
	1.) <input type='text' name='three_1' size='72' maxlength='80'/><br>
	2.) <input type='text' name='three_2' size='72' maxlength='80'/><br>
	3.) <input type='text' name='three_3' size='72' maxlength='80'/><br>
	4.) <input type='text' name='three_4' size='72' maxlength='80'/><br>
	5.) <input type='text' name='three_5' size='72' maxlength='80'/><br><br>
	<hr size='6' noshade style='width:600px'>

	<font color='red'>When you hit submit, an email will get generated and sent to:<br>
	Your manager, Your team lead, and Yourself.<br>
	<input type=hidden name='form' value='true'>
	<input type='submit' name='submit'>
	</form>

	</center>

	<!--ACTUAL WEB STUFF-->
	</body>
	</html>";
}


#------------#
# Send Email #
#------------#
# sendmail($to_email, $cc_email, $subject, $body);
sub sendemail {
    my ($to_email, $cc_email, $subject, $body) = @_;
    my $from_email = "weekly-status-report\@fas.harvard.edu";

    my $msg = MIME::Lite->new(
                 From     =>"$from_email",
                 To       =>"$to_email",
                 Cc       =>"$cc_email",
                 Subject  =>"$subject",
                 Data     =>"$body"
                 );
    $msg->send;
}

sub error {
	my $msg = shift;
	print "Content-type:text/html\r\n\r\n";
	print "<html><head><title>ERROR - Status Review</title></head>";
	print "<body>$msg < <a href=\"javascript:history.go(-1)\">GO BACK</a> ><br></body></html>";
	exit;
}

1;
